#include <stdio.h>
#include <stdlib.h>

/* Realizzare una funzione draw_triangle() per stampare su schermo
   triangoli come questo:

9 
8 
7 
6 
5         *
4        **
3       ***
2      ****
1     *****
0    ******
  0123456789

   La funzione accetta come parametri tre interi: x0, y0, l.  (x0,y0)
   rappresenta la coordinata dell'angolo in alto del triangolo, e l
   rappresenta la lunghezza (numero di asterischi) della base o
   dell'altezza del triangolo.

   x0, y0 sono compresi tra 0 e 9 (estremi inclusi); l e' compreso tra
   1 e 10 (estremi inclusi). Il triangolo e' rettangolo
   isoscele. Nella figura precedente, ad esempio si ha x0=8, y0=5,
   l=6. Il punto di coordinate (0,0) e' quello in basso a sinistra. Il
   triangolo deve sempre essere orientato come mostrato in figura.

   Si garantisce che i parametri passati alla funzione siano sempre
   validi, e consentano di disegnare un triangolo interamente
   contenuto nella porzione di piano compresa tra le coordinate (0,0)
   e (9,9) come mostrato. Si noti che i numeri sugli assi fanno parte
   di quanto deve essere stampato dalla funzione.

   Si inseriscano poi nel main() delle opportune chiamate alla
   funzione draw_triangle che disegnino le figure seguenti:

9          *
8         **
7        ***
6       ****
5      *****
4     ******
3    *******
2   ********
1  *********
0 **********
  0123456789

9 
8 
7 
6     *
5    **
4   ***
3  ****
2 
1 
0 
  0123456789

9 
8 
7 
6 
5      *
4     **
3 
2 
1 
0 
  0123456789

   (e' parte dell'esercizio determinare i parametri di input da usare
   per ciascuna figura). Ovviamente la funzione realizzata deve essere
   in grado di visualizzare correttamente qualsiasi triangolo valido.

   E' sempre possibile definire ulteriori funzioni di supporto, se
   necessario.
*/
/* Stampa n occorrenze del carattere c */
void symb(char c, int n)
{
    int i;
    for (i=0; i<n; i++) {
        printf("%c", c);
    }
}

void draw_triangle(int x0, int y0, int l)
{
    int y;

    for (y = 9; y >= 0; y--) {
        printf("%d ", y);
        if (y <= y0 && y > y0-l) {
            symb(' ', x0-y0+y);
            symb('*', y0-y+1);
        }
        printf("\n");
    }
    printf("  0123456789\n\n");
}

int main( void )
{
    draw_triangle(8, 5, 6);
    draw_triangle(9, 9, 10);
    draw_triangle(5, 6, 4);
    draw_triangle(5, 5, 2);
    return 0;
}
