#include <stdio.h>
#include <stdlib.h>

/* Dato un array non vuoto di interi tutti distinti avente lunghezza
   dispari n>=1, la mediana e' il valore di v che risulta strettamente
   maggiore di (n-1)/2 valori, e strettamente minore dei rimanenti
   (n-1)/2 valori. Poiche' si garantisce che l'array abbia lunghezza
   dispari e contenga tutti valori distinti, la mediana risultera'
   sempre univocamente determinata. La mediana di un array con un
   singolo elemento e' il valore dell'unico elemento presente. 

   Realizzare la funzione f(v, n) seguente che restituisca la mediana
   di un array v di n elementi tutti distinti, con n>=1 e dispari.

   I test inclusi in questo programma sono insufficienti per
   verificarne la correttezza. E' richiesto di aggiungere almeno TRE
   ulteriori casi di test. (Si ricordi comunque che una funzione che
   supera i test non e' necessariamente corretta).

   Il contenuto degli array di test non devono essere chiesti
   all'utente, ma definiti in modo opportuno nel main().  Si puo'
   utilizzare la funzione di test gia' fornita, oppure creare del
   codice ad hoc.

   E' sempre consentito definire ulteriori funzioni di supporto, se
   necessario.
*/
int f( int v[], int n )
{
    int i;
    for (i=0; i<n; i++) {
        /* Invariante: n_minori e' il numero di valori di v[] che
           risultino strettamente minori di v[i] */
        int j, n_minori = 0;
        for (j=0; j<n; j++) {
            if (v[j] < v[i]) n_minori++;
        }
        if (n_minori == (n-1)/2) {
            return v[i];
        }
    }
    return 0; /* in base alle specifiche, questa istruzione non verra'
                 mai eseguita. Dobbiamo pero' mettere un "return"
                 anche qui per evitare un warning del compilatore. */
}

void test(int v[], int n, int atteso)
{
    int ottenuto = f(v, n);
    if (atteso==ottenuto) {
        printf("Test OK\n");
    } else {
        printf("Test FALLITO: risultato atteso=%d, risultato ottenuto=%d\n", atteso, ottenuto);
    }
}


int main( void )
{
    #define ARRAY_LEN(v) (sizeof(v)/sizeof(v[0]))    
    int v1[] = {1, 2, 3};
    int v2[] = {3, 1, -1, -2, 10, 11, 12};
    int v3[] = {99};
    int v4[] = {-13, 21, 18, 3, -1, -2, -7, 2, 5};
    int v5[] = {3, 2, 1};
    
    test(v1, ARRAY_LEN(v1), 2);
    test(v2, ARRAY_LEN(v2), 3);
    test(v3, ARRAY_LEN(v3), 99);
    test(v4, ARRAY_LEN(v4), 2);
    test(v5, ARRAY_LEN(v5), 2);
    return 0;
}
