#include <stdio.h>
#include <stdlib.h>

/* Realizzare la funzione f(v, n) secondo le specifiche seguenti. La
   funzione accetta come parametro un array non vuoto v[] di interi, e
   la sua lunghezza n>=1. La funzione deve restituire il valore piu'
   frequente di v[], cioe' il valore che compare il maggior numero di
   volte. In caso di parita', si restituisca uno dei valori che
   compaiono il numero massimo di volte.

   Ad esempio, se v[] = {13, 8, -5, 13, 19, 8}, i valori piu'
   frequenti sono 13 oppure 8 (ciascuno compare 2 volte), quindi la
   funzione puo' restituire uno dei due. Se v[] = {91, 3, 2, -5, 3,
   18, 3, 3}, il valore piu' frequente e' 3, che compare 4 volte.

   I test inclusi in questo programma sono insufficienti per
   verificarne la correttezza. E' richiesto di aggiungere almeno TRE
   ulteriori casi di test. Predisporre casi di test in cui il valore
   piu' frequente sia univocamente determinato. (Si ricordi comunque
   che una funzione che supera i test non e' necessariamente corretta).

   Il contenuto degli array di test non devono essere chiesti
   all'utente, ma definiti in modo opportuno nel main().  Si puo'
   utilizzare la funzione di test gia' fornita, oppure creare del
   codice ad hoc.

   E' sempre consentito definire ulteriori funzioni di supporto, se
   necessario.
*/

int f( int v[], int n )
{
    int i;
    int moda_val; /* valore della moda */
    int moda_freq = -1; /* n. di occorrenze di moda_val in v[] */
    for (i=0; i<n; i++) {
        /* invariante: occ e' il numero di occorrenze di v[i] */
        int j, occ = 0;
        for (j=0; j<n; j++) {
            if (v[i] == v[j]) occ++;
        }
        if (occ > moda_freq) {
            moda_freq = occ;
            moda_val = v[i];
        }
    }
    return moda_val;
}

void test(int v[], int n, int atteso)
{
    int ottenuto = f(v, n);
    if (atteso==ottenuto) {
        printf("Test OK\n");
    } else {
        printf("Test FALLITO: risultato atteso=%d, risultato ottenuto=%d\n", atteso, ottenuto);
    }
}

int main( void )
{
    #define ARRAY_LEN(v) (sizeof(v)/sizeof(v[0]))
    /* A lezione non abbiamo trattato le macro, comunque
       scrivere ARRAY_LEN(v) equivale a scrivere l'espressione
       
       (sizeof(v) / sizeof(v[0]))
    */
    int v1[] = {1, 2, 3, 4, 5, 5, 1, 2, 2, 2, 1, 2, 2};
    int v2[] = {10, 10, 10, 9, 10, 10, 1, 2, 3, -6, -10};
    int v3[] = {99};
    int v4[] = {9, -1, 2, -6, -6, -6, -1, -1, 9, -1, -1, 18, -1, 21, -1};
    int v5[] = {2, 2};
    int v6[] = {91, 3, 2, -5, 3, 18, 3};
    
    test(v1, ARRAY_LEN(v1), 2);
    test(v2, ARRAY_LEN(v2), 10);
    test(v3, ARRAY_LEN(v3), 99);
    test(v4, ARRAY_LEN(v4), -1);
    test(v5, ARRAY_LEN(v5), 2);
    test(v6, ARRAY_LEN(v6), 3);
    return 0;
}
